org.jgroups.protocols.pbcast

## Class STABLE

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.pbcast.STABLE

    public class STABLE
    extends Protocol

Computes the broadcast messages that are stable; i.e., have been received by all members. Sends STABLE events up the stack when this is the case. This allows NAKACK to garbage collect messages that have been seen by all members.

Works as follows: periodically we mcast our highest seqnos (seen for each member) to the group. A stability vector, which maintains the highest seqno for each member and initially contains no data, is updated when such a message is received. The entry for a member P is computed set to min(entry[P], digest[P]). When messages from all members have been received, a stability message is mcast, which causes all members to send a STABLE event up the stack (triggering garbage collection in the NAKACK layer).

New: when `max_bytes` is exceeded (unless disabled by setting it to 0), a STABLE task will be started (unless it is already running). Design in docs/design/STABLE.txt

Author:
  Bela Ban

### Nested Class Summary

Nested Classes
`static class` `STABLE.StableHeader`

### Field Summary

Fields
`protected double` `cap`
`protected long` `max_bytes` Total amount of bytes from incoming messages (default = 0 = disabled).
`protected java.lang.management.MemoryMXBean` `memory_manager`
`protected long` `original_max_bytes`

### Fields inherited from class org.jgroups.stack.Protocol

`down_prot, ergonomics, id, log, name, stack, stats, up_prot`

### Constructor Summary

Constructors
Constructor and Description
`STABLE()`

### Method Summary

Methods
`java.lang.Object` `down(Event evt)` An event is to be sent down the stack.
`long` `getBytes()`
`long` `getDesiredAverageGossip()`
`long` `getMaxBytes()`
`int` `getStabilityReceived()`
`int` `getStabilitySent()`
`int` `getStableReceived()`
`int` `getStableSent()`
`boolean` `getStableTaskRunning()`
`void` `init()` Called after instance has been created (null constructor) and before protocol is started.
`java.util.Vector<java.lang.Integer>` `requiredDownServices()` List of events that are required to be answered by some layer below.
`void` `resetStats()`
`void` `runMessageGarbageCollection()`
`void` `setDesiredAverageGossip(long gossip_interval)`
`void` `setMaxBytes(long max_bytes)`
`void` `start()` This method is called on a `Channel.connect(String)`.
`void` `stop()` This method is called on a `Channel.disconnect()`.
`java.lang.Object` `up(Event evt)` An event was received from the layer below.

### Methods inherited from class org.jgroups.stack.Protocol

`destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### max_bytes

    protected long max_bytes

Total amount of bytes from incoming messages (default = 0 = disabled). When exceeded, a STABLE message will be broadcast and `num_bytes_received` reset to 0 . If this is > 0, then ideally `stability_delay` should be set to a low number as well

#### original_max_bytes

    protected long original_max_bytes

#### cap

    protected double cap

#### memory_manager

    protected final java.lang.management.MemoryMXBean memory_manager

### Constructor Detail

#### STABLE

    public STABLE()

### Method Detail

#### getDesiredAverageGossip

    public long getDesiredAverageGossip()

#### setDesiredAverageGossip

    public void setDesiredAverageGossip(long gossip_interval)

#### getMaxBytes

    public long getMaxBytes()

#### setMaxBytes

    public void setMaxBytes(long max_bytes)

#### getBytes

    public long getBytes()

#### getStableSent

    public int getStableSent()

#### getStableReceived

    public int getStableReceived()

#### getStabilitySent

    public int getStabilitySent()

#### getStabilityReceived

    public int getStabilityReceived()

#### getStableTaskRunning

    public boolean getStableTaskRunning()

#### resetStats

    public void resetStats()

Overrides:
  `resetStats` in class `Protocol`

#### requiredDownServices

    public java.util.Vector<java.lang.Integer> requiredDownServices()

Description copied from class: `Protocol`
List of events that are required to be answered by some layer below.

Overrides:
  `requiredDownServices` in class `Protocol`
Returns:
  Vector (of Integers)

#### init

    public void init()
              throws java.lang.Exception

Description copied from class: `Protocol`
Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.

Overrides:
  `init` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

#### start

    public void start()
               throws java.lang.Exception

Description copied from class: `Protocol`
This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.

Overrides:
  `start` in class `Protocol`
Throws:
  `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

#### stop

    public void stop()

Description copied from class: `Protocol`
This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed

Overrides:
  `stop` in class `Protocol`

#### up

    public java.lang.Object up(Event evt)

Description copied from class: `Protocol`
An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.

Overrides:
  `up` in class `Protocol`

#### down

    public java.lang.Object down(Event evt)

Description copied from class: `Protocol`
An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.

Overrides:
  `down` in class `Protocol`

#### runMessageGarbageCollection

    public void runMessageGarbageCollection()